using System;

/// @author  Vesa Lappalainen
/// @version 12.11.2012
/// <summary>
/// Keroman laskeminen kahdella eri tavalla
/// </summary>
public class Rekursio
{
    /// <summary>
    /// Kutsutaan erilaisia kertoman toteutuksia
    /// </summary>
    public static void Main()
    {
        long tulos = Kertoma(16);
        long tulosf = KertomaFor(4);
        Console.WriteLine(tulos + " " + tulosf);
    }


    /// <summary>
    /// Palauttaa n:än kertoman kaavasta:
    /// <example>
    /// n! = n * (n-1)!
    /// 1! = 1
    /// 0! = 1
    /// </example>
    /// </summary>
    /// <param name="n">minkäluvun kertoma</param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    ///   Kertoma(0) === 1L;
    ///   Kertoma(1) === 1L;
    ///   Kertoma(2) === 2L;
    ///   Kertoma(5) === 120L;
    ///   Kertoma(6) === 720L;
    /// </pre>
    /// </example>
    public static long Kertoma(long n)
    {
        if (n <= 1) return 1;
        return n * Kertoma(n - 1);
    }


    /// <summary>
    /// Palauttaa n:n kertoman iteraatiolla laskettuna
    /// <example>
    /// n! = n * (n-1)!
    /// 1! = 1
    /// 0! = 1
    /// </example>
    /// </summary>
    /// <param name="n">minkäluvun kertoma</param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    ///   KertomaFor(0) === 1L;
    ///   KertomaFor(1) === 1L;
    ///   KertomaFor(2) === 2L;
    ///   KertomaFor(5) === 120L;
    ///   KertomaFor(6) === 720L;
    /// </pre>
    /// </example>
    public static long KertomaFor(long n)
    {
        long tulos = 1;
        for (int i = 2; i <= n; i++)
        {
            tulos *= i;
        }
        return tulos;
    }


}
